package com.zhibao.crm.cms.handler;

import com.jfinal.handler.Handler;
import com.jfinal.plugin.activerecord.Db;
import com.zhibao.crm.cms.UrlRewriteWrappedRequest;
import com.zhibao.crm.cms.entity.Company;
import com.zhibao.crm.cms.entity.Site;
import com.zhibao.crm.cms.entity.Web;
import com.zhibao.crm.cms.util.SiteUtils;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SiteHandler extends Handler {

   private List urlExcludes = new ArrayList() {
      {
         this.add("/category");
         this.add("/content");
         this.add("/api");
      }
   };


   public void handle(String target, HttpServletRequest request, HttpServletResponse response, boolean[] isHandled) {
      if(target.startsWith("/cms/admin/")) {
         this.next.handle(target, request, response, isHandled);
      } else {
         String domain = SiteUtils.getDomain(request);
         String[] urls = target.split("/");
         Integer siteNum = Db.queryInt("select count(*) from crm_cms_site where domain=?", new Object[]{domain});
         String site;
         Site site1;
         Site site2;
         if(siteNum != null && siteNum.intValue() >= 1) {
            if(urls.length < 1) {
               site2 = (Site)((Site)(new Site()).dao()).findFirst("select * from crm_cms_site where domain=? and cat is null", new Object[]{domain});
               this.wrappedRequest(site2, target, request, response, isHandled);
               return;
            }

            site = urls[1];
            if(!this.urlExcludes.contains("/" + site)) {
               site1 = (Site)((Site)(new Site()).dao()).findFirst("select * from crm_cms_site where domain=? and cat = ?", new Object[]{domain, site});
               if(site1 != null) {
                  target = target.substring(("/" + site).length());
                  this.wrappedRequest(site1, target, request, response, isHandled);
                  return;
               }
            }
         } else {
            if(urls.length < 1) {
               site2 = ((Site)(new Site()).dao()).findDefault();
               this.wrappedRequest(site2, target, request, response, isHandled);
               return;
            }

            site = urls[1];
            if(!this.urlExcludes.contains("/" + site)) {
               site1 = (Site)((Site)(new Site()).dao()).findFirst("select * from crm_cms_site where domain is null and cat = ?", new Object[]{site});
               if(site1 != null) {
                  target = target.substring(("/" + site).length());
                  this.wrappedRequest(site1, target, request, response, isHandled);
                  return;
               }
            }
         }

         site2 = ((Site)(new Site()).dao()).findDefault();
         this.wrappedRequest(site2, target, request, response, isHandled);
      }
   }

   public void wrappedRequest(Site site, String target, HttpServletRequest request, HttpServletResponse response, boolean[] isHandled) {
      request.setAttribute("currentSite", site);
      request.setAttribute("currentWeb", ((Web)(new Web()).dao()).findBySiteId(site.getId()));
      request.setAttribute("currentCompany", ((Company)(new Company()).dao()).findBySiteId(site.getId()));
      HashMap overridenParameters = new HashMap();
      UrlRewriteWrappedRequest urlRewriteWrappedRequest = new UrlRewriteWrappedRequest(request, overridenParameters);
      this.next.handle(target, urlRewriteWrappedRequest, response, isHandled);
   }
}
